<?
   error_reporting(E_ALL ^ E_NOTICE);

   import("smarty.*");
   import("db.*");

   /* 
    *   Smarty engine
    */
   define('BASE_DIR', dirname(__FILE__));
   $system_root_path = BASE_DIR . "/";

   define('SMARTY_DIR', BASE_DIR . '/Smarty-2.6.2/libs/');
   require_once(SMARTY_DIR.'Smarty.class.php');
   $smarty = new Smarty;
   $smarty->template_dir = BASE_DIR . '/templates/';
   $smarty->compile_dir = BASE_DIR . '/templates_c/';
   $smarty->config_dir = BASE_DIR . '/configs/';
   $smarty->cache_dir = BASE_DIR . '/cache/';

  $smarty->assign ("now", date("r"));

   require_once($system_root_path . "main_config.php");

    if (file_exists($system_root_path . "config.php") &&
       filesize($system_root_path . "config.php") > 0) {

     require_once($system_root_path . "config.php");


     $config["db_dbms"] = "mysql";
    if(empty($config["db_dbms"])) {
      $config["db_dbms"] = "mysql";
    } 
    _init_DB ($config["db_dbms"]);

     $db = new sql_db ($config["db_host"], 
                      $config["db_user"], 
                        $config["db_password"], 
                         $config["itw_db_database"]);

     if (!$db->db_connect_id) {
      echo ("Cannot connect to worktime database<br/>");
    } else {
      useDatabase ("itw");
      checkDbStructure ($db, join("", file(BASE_DIR . "/data/sql/itw.sql")));
    }
   }

   @session_start ();
   @session_register ("user_login");
   @session_register ("user_password");

   session_set_cookie_params(0);

  $user_login = $HTTP_SESSION_VARS["user_login"];
  $user_password = $HTTP_SESSION_VARS["user_password"];

  $isAdmin = false;
  $isLogged = false;

  if (strlen ($config["admin_login"]) > 0 && 
     strlen ($config["admin_password"]) > 0) {
    if ($user_login == $config["admin_login"] && 
       $user_password == $config["admin_password"]) {
      $isLogged = true;
      $isAdmin = true;
    } else {
      if ($db->db_connect_id) {
        $q = "select * from profiles where login_name='$user_login'";
        useDatabase ("bug");
        $rs = $db->sql_query ($q);
        $profile = $db->sql_fetchrow ($rs);
        $db->sql_freeresult ($rs);
        if ($profile ["login_name"] === $user_login) {
          if ($profile ["cryptpassword"] == crypt($user_password, $profile ["cryptpassword"])) {
            $isLogged = true;
            $smarty->assign ("profile", $profile);
          }
        }
      }
    }
  } else {
    $isLogged = true;
    $isAdmin = true;
  }

  $smarty->assign ("is_admin", $isAdmin);
  $smarty->assign ("is_logged", $isLogged);

  /**********************************************************************************
    Service code  
  **********************************************************************************/

   function import ($p) {
      $p = split("\.", $p);
      $path = dirname(__FILE__);
      include_once("$path/classes/" . $p[0] . "/.package.php");
   }

  function checkAdmin () {
    global $isAdmin;
    if (!$isAdmin) redirect ("index.html");
  }

  function checkLogged () {
    global $isLogged;
    if (!$isLogged) redirect ("index.html");
  }

  function checkDbStructure (&$db, $structure) {
    $queries = explode (";", $structure);
    
    $rs = $db->sql_query ("show tables");
    $r = $db->sql_fetchrowset ($rs);
    $db->sql_freeresult ($rs);

    $existTables = array ();
    foreach ($r as $k => $v) {
      $existTables[] = $v [0];
    }

    foreach ($queries as $q) {
      $q = trim ($q);
      if (strlen ($q) > 0) {
        if (preg_match ("|^\s*CREATE\s+TABLE\s+(\w+)|", $q, $ar)) {
          $tableName = $ar [1];
          if (!in_array($tableName, $existTables)) {
            echo ("creating table $tableName ...<br/>");
                $rs = $db->sql_query ($q);
                $r = $db->sql_fetchrowset ($rs);
                $db->sql_freeresult ($rs);
          }
        } else {
          die ("error: database structure not understood: $q");
        }
      }
    }
  }
  
  function redirect ($url) {
    header ("302");
    header ("Location: $url");
    die ();
  }
  
  function useDatabase ($name) {
    global $config, $db;
    if ($name == "bug") {
      $rs = $db->sql_query ("use " . $config ["bug_db_database"]);
      $db->sql_freeresult ($rs);
    } else {
      $rs = $db->sql_query ("use " . $config ["itw_db_database"]);
      $db->sql_freeresult ($rs);
    }
  }
?>